define(["dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/string",
        "dijit/_Widget",        
        "dijit/_TemplatedMixin",
        "dijit/_WidgetsInTemplateMixin",
        "dojo/text!./templates/LDAPFiltersWizardPage.html",
        "dojo/i18n!../nls/user_resources",
        "admin/users/dialogs/WizardPage",
        "dojo/dom-style",
        "dojo/string",
        "dijit/form/RadioButton",
        "dojox/form/Uploader",
        "dojox/form/uploader/plugins/IFrame",
        "idx/form/TextBox",
        "idx/form/RadioButtonSet",
        "idx/form/Select"
        ],
        function(dDeclare,
                dLang,
                dString,
                dWidget,
                dTemplatedMixin,
                dWidgetsInTemplateMixin,
                templateText,
                resources,
                WizardPage,
                domStyle,
                dString) {
return dDeclare("admin.users.dialogs.LDAPFiltersWizardPage", [dWidget,dTemplatedMixin,dWidgetsInTemplateMixin,WizardPage], {

	/**
     * The widget template for the dijit._TemplatedMixin base class.
     */
    templateString: templateText,
    
    /** 
     * Indicate if this widget is also a container
     * @private
     */
    isContainer: false,
    
    /**
     * Indicate if there are widgets in the template
     */
    widgetsInTemplate: true,
    
    fieldWidth: 150,
    
    pageDescription: resources["ldapFilterDescription"],
    
    dnLabel: resources["baseDNLabel"],
    
    dnExample: resources["baseDNExample"],
    
    groupFilterLabel: resources["groupFilterLabel"],
    
    groupFilterExample: resources["groupFilterExample"],
    
    groupAttributeLabel: resources["groupAttributeLabel"],
    
    groupAttributeExample: resources["groupAttributeExample"],
    
    userFilterAttributeLabel: resources["userFilterAttributeLabel"],
    
    userFilterAttributeExample: resources["userFilterAttributeExample"],
    
    userNameAttributeLabel: resources["userNameAttributeLabel"],
    
    userNameAttributeExample: resources["userNameAttributeExample"],
    
    logonIDAttributeLabel: resources["logonIDAttributeLabel"],
    
    logonIDAttributeExample: resources["logonIDAttributeExample"],
    
    userEmailAttributeLabel: resources["userEmailAttributeLabel"],
    
    userEmailAttributeExample: resources["userEmailAttributeExample"],
    
    /**
	 * Get the description of this page
	 */
	getDescription:function() {
		return this.pageDescription;
	},
    
	/**
	 * Check if this page is complete
	 */
	isComplete:function() {
		if(dString.trim(this.dnNode.get("value")) == "") {
			return false;
		}
		else if(dString.trim(this.groupNode.get("value")) == "") {
			return false;
		}
		else if(dString.trim(this.groupAttributesNode.get("value")) == "") {
			return false;
		}
		else if(dString.trim(this.userNameAttributeNode.get("value")) == "") {
			return false;
		}
		else if(dString.trim(this.userFilterAttributeNode.get("value")) == "") {
			return false;
		}
		else if(dString.trim(this.userIDAttributeNode.get("value")) == "") {
			return false;
		}
		else if(dString.trim(this.userEmailAttributeNode.get("value")) == "") {
			return false;
		}
		return true;
	},
	
	/**
	 * The startup function
	 */
	startup:function() {
		this.inherited(arguments);
		this.dnNode.on("change", dLang.hitch(this, "_validate"));
		this.groupNode.on("change", dLang.hitch(this, "_validate"));
		this.groupAttributesNode.on("change", dLang.hitch(this, "_validate"));
		this.userNameAttributeNode.on("change", dLang.hitch(this, "_validate"));
		this.userFilterAttributeNode.on("change", dLang.hitch(this, "_validate"));
		this.userIDAttributeNode.on("change", dLang.hitch(this, "_validate"));
		this.userEmailAttributeNode.on("change", dLang.hitch(this, "_validate"));
		this.dnNode.set('intermediateChanges', true);
		this.groupNode.set('intermediateChanges', true);
		this.groupAttributesNode.set('intermediateChanges', true);
		this.userNameAttributeNode.set('intermediateChanges', true);
		this.userEmailAttributeNode.set('intermediateChanges', true);
		console.log("startup complete.")
	},
	
	/**
	 * Filter value changed
	 */
	_validate:function(data) {
		this.controller.updateWizardButtonStates();
	},
	
    /**
     * Get the LDAP filters
     */
    getLDAPFilters:function() {
    	var filters = {"groupFilter":this.groupNode.get("value"),
				"baseDN":this.dnNode.get("value"),
				"groupReturnAttributes":this.groupAttributesNode.get("value"),
				"userFilterMap":this.userFilterAttributeNode.get("value"),
				"userNameMap":this.userNameAttributeNode.get("value"),
				"userIdMap":this.userIDAttributeNode.get("value"),
				"userEmailMap":this.userEmailAttributeNode.get("value")
		};
    	return filters;
    }
});
});
